#include "POV.h"

// Global Variables
unsigned long currentTime, previousRead, frameGroupDuration, frameStartTime, frameDuration;
//bool idle = 1;

// Global Objects
POV wheel = POV(CLOCK_PIN, LATCH_PIN, DATA_PIN);
imageClass image;

void setup()
{
#ifdef DEBUG
	Serial.begin(57600);
	Serial.println("starting");
#endif
	unsigned long now = micros();
	frameDuration = 50000;
	image.startTime = now;
	wheel.display(&image);
}

void loop()
{
	currentTime = micros();
#ifdef DEBUG
	Serial.println(currentTime);
#endif

	// Check for a sensor reading
	if(wheel.readSensors())
	{
		// Update how long each frame is displayed
		updateFrameTiming();
	}
	else if((currentTime - frameStartTime) > frameDuration)
	{
		advanceFrame();
	};
	
	if((currentTime - image.startTime) > image.duration) {
		image.cyclePatterns(currentTime);
		
	}
}

void advanceFrame()
{
#ifdef DEBUG
	Serial.println("advanceFrame()");
#endif
	frameStartTime = currentTime;
	wheel.advanceCurrentFrame();
	wheel.display(&image);

}

void updateFrameTiming()
{
#ifdef DEBUG
	Serial.println("updateFrameTiming()");
#endif
	frameGroupDuration = currentTime - previousRead;
	frameDuration = frameGroupDuration / (FRAME_GROUP);
	frameStartTime = currentTime;
	if (frameDuration > 50000) frameDuration = 50000;
	previousRead = currentTime;
}