
//#define DEBUG 1
#include <Arduino.h>
#include "Spoke.h"
#include "Image.h"

// Preprocessor
// Define some constants to save some memory on the device.
#define DATA_PIN 13
#define CLOCK_PIN 8
#define LATCH_PIN 9
#define A_L_ENABLE 2
#define A_R_ENABLE 3
#define B_L_ENABLE 4
#define B_R_ENABLE 5
#define C_L_ENABLE 6
#define C_R_ENABLE 7
#define A_SENSOR 10
#define B_SENSOR 11
#define C_SENSOR 12

class POV
{
public:
	POV(uint8_t clock, uint8_t latch, uint8_t data);

	bool readSensors();
	void display(imageClass *image);
	void advanceCurrentFrame();
	bool idle();

private:
	// Create spoke objects
	spoke spokes[3];

	// Class variables
	uint8_t clockPin, latchPin, dataPin, currentFrame[3], enableByte, nextSensor;
	unsigned long previousRead, frameGroupInterval;

	void updateFrameTiming();
	void setCurrentFrame(uint8_t aFrame);
	void setupSingleSpoke(imageClass *image, uint8_t spoke);
	void shiftOneByte(uint8_t data);
	void setEnableByte(uint8_t data, uint8_t spoke);
	void latch();
};